searchData={"items":[{"type":"module","title":"NervesHubLink","doc":"","ref":"NervesHubLink.html"},{"type":"function","title":"NervesHubLink.connected?/0","doc":"Checks if the device is connected to the NervesHub device channel.","ref":"NervesHubLink.html#connected?/0"},{"type":"function","title":"NervesHubLink.console_active?/0","doc":"Return whether there's currently an active console session","ref":"NervesHubLink.html#console_active?/0"},{"type":"function","title":"NervesHubLink.console_connected?/0","doc":"","ref":"NervesHubLink.html#console_connected?/0"},{"type":"function","title":"NervesHubLink.reconnect/0","doc":"Restart the socket and device channel","ref":"NervesHubLink.html#reconnect/0"},{"type":"function","title":"NervesHubLink.send_file/1","doc":"Send a file to the connected console","ref":"NervesHubLink.html#send_file/1"},{"type":"function","title":"NervesHubLink.send_update_progress/1","doc":"Send update progress percentage for display in web","ref":"NervesHubLink.html#send_update_progress/1"},{"type":"function","title":"NervesHubLink.send_update_status/1","doc":"Send an update status to web","ref":"NervesHubLink.html#send_update_status/1"},{"type":"function","title":"NervesHubLink.socket_connected?/0","doc":"Checks if the device has a socket connection with NervesHub","ref":"NervesHubLink.html#socket_connected?/0"},{"type":"function","title":"NervesHubLink.status/0","doc":"Current status of the update manager","ref":"NervesHubLink.html#status/0"},{"type":"module","title":"NervesHubLink.Application","doc":"","ref":"NervesHubLink.Application.html"},{"type":"function","title":"NervesHubLink.Application.start/2","doc":"","ref":"NervesHubLink.Application.html#start/2"},{"type":"module","title":"NervesHubLink.Backoff","doc":"Compute retry backoff intervals used by Slipstream","ref":"NervesHubLink.Backoff.html"},{"type":"function","title":"NervesHubLink.Backoff.delay_list/3","doc":"Produce a list of integer backoff delays with jitter\n\nThe first two parameters are minimum and maximum value. These are expected to\nbe milliseconds, but this function doesn't care. The returned list will start\nwith the minimum value and then double it until it reaches the maximum value.\n\nThe third parameter is the amount of jitter to add to each delay. The value\nshould be between 0 and 1. Zero adds no jitter. A value like 0.25 will add up\nto 25% of the delay amount.","ref":"NervesHubLink.Backoff.html#delay_list/3"},{"type":"module","title":"NervesHubLink.Certificate","doc":"","ref":"NervesHubLink.Certificate.html"},{"type":"function","title":"NervesHubLink.Certificate.ca_certs/0","doc":"Returns a list of der encoded CA certs","ref":"NervesHubLink.Certificate.html#ca_certs/0"},{"type":"function","title":"NervesHubLink.Certificate.fwup_public_keys/0","doc":"","ref":"NervesHubLink.Certificate.html#fwup_public_keys/0"},{"type":"function","title":"NervesHubLink.Certificate.key_pem_to_der/1","doc":"","ref":"NervesHubLink.Certificate.html#key_pem_to_der/1"},{"type":"function","title":"NervesHubLink.Certificate.pem_to_der/1","doc":"","ref":"NervesHubLink.Certificate.html#pem_to_der/1"},{"type":"behaviour","title":"NervesHubLink.Client","doc":"A behaviour module for customizing if and when firmware updates get applied.\n\nBy default NervesHubLink applies updates as soon as it knows about them from the\nNervesHubLink server and doesn't give warning before rebooting. This let's\ndevices hook into the decision making process and monitor the update's\nprogress.\n\n# Example\n\n```elixir\ndefmodule MyApp.NervesHubLinkClient do\n  @behaviour NervesHubLink.Client\n\n  # May return:\n  #  * `:apply` - apply the action immediately\n  #  * `:ignore` - don't apply the action, don't ask again.\n  #  * `{:reschedule, timeout_in_milliseconds}` - call this function again later.\n\n  @impl NervesHubLink.Client\n  def update_available(data) do\n    if SomeInternalAPI.is_now_a_good_time_to_update?(data) do\n      :apply\n    else\n      {:reschedule, 60_000}\n    end\n  end\nend\n```\n\nTo have NervesHubLink invoke it, add the following to your `config.exs`:\n\n```elixir\nconfig :nerves_hub_link, client: MyApp.NervesHubLinkClient\n```","ref":"NervesHubLink.Client.html"},{"type":"function","title":"NervesHubLink.Client.handle_error/1","doc":"This function is called internally by NervesHubLink to notify clients of fwup errors.","ref":"NervesHubLink.Client.html#handle_error/1"},{"type":"callback","title":"NervesHubLink.Client.handle_error/1","doc":"Called when downloading a firmware update fails.\n\nThe return value of this function is not checked.","ref":"NervesHubLink.Client.html#c:handle_error/1"},{"type":"function","title":"NervesHubLink.Client.handle_fwup_message/1","doc":"This function is called internally by NervesHubLink to notify clients of fwup progress.","ref":"NervesHubLink.Client.html#handle_fwup_message/1"},{"type":"callback","title":"NervesHubLink.Client.handle_fwup_message/1","doc":"Called on firmware update reports.\n\nThe return value of this function is not checked.","ref":"NervesHubLink.Client.html#c:handle_fwup_message/1"},{"type":"function","title":"NervesHubLink.Client.identify/0","doc":"This function is called internally by NervesHubLink to identify a device.","ref":"NervesHubLink.Client.html#identify/0"},{"type":"callback","title":"NervesHubLink.Client.identify/0","doc":"Callback to identify the device from NervesHub.","ref":"NervesHubLink.Client.html#c:identify/0"},{"type":"function","title":"NervesHubLink.Client.initiate_reboot/0","doc":"This function is called internally by NervesHubLink to initiate a reboot.\n\nAfter a successful firmware update, NervesHubLink calls this to start the\nreboot process. It calls `c:reboot/0` if supplied or\n`Nerves.Runtime.reboot/0`.","ref":"NervesHubLink.Client.html#initiate_reboot/0"},{"type":"callback","title":"NervesHubLink.Client.reboot/0","doc":"Optional callback to reboot the device when a firmware update completes\n\nThe default behavior is to call `Nerves.Runtime.reboot/0` after a successful update. This\nis useful for testing and for doing additional work like notifying users in a UI that a reboot\nwill happen soon. It is critical that a reboot does happen.","ref":"NervesHubLink.Client.html#c:reboot/0"},{"type":"function","title":"NervesHubLink.Client.reconnect_backoff/0","doc":"This function is called internally by NervesHubLink to notify clients of disconnects.","ref":"NervesHubLink.Client.html#reconnect_backoff/0"},{"type":"callback","title":"NervesHubLink.Client.reconnect_backoff/0","doc":"Optional callback when the socket disconnected, before starting to reconnect.\n\nThe return value is used to reset the next socket's retry timeout. `nil` uses\nthe default. The default is a call to `NervesHubLink.Backoff.delay_list/3`.\n\nYou may wish to use this to dynamically change the reconnect backoffs. For instance,\nduring a NervesHub deploy you may wish to change the reconnect based on your\nown logic to not create a thundering herd of reconnections. If you have a particularly\nflaky connection you can increase how fast the reconnect happens to avoid overloading\nyour server.","ref":"NervesHubLink.Client.html#c:reconnect_backoff/0"},{"type":"function","title":"NervesHubLink.Client.update_available/1","doc":"This function is called internally by NervesHubLink to notify clients.","ref":"NervesHubLink.Client.html#update_available/1"},{"type":"callback","title":"NervesHubLink.Client.update_available/1","doc":"Called to find out what to do when a firmware update is available.\n\nMay return one of:\n\n* `apply` - Download and apply the update right now.\n* `ignore` - Don't download and apply this update.\n* `{:reschedule, timeout}` - Defer making a decision. Call this function again in `timeout` milliseconds.","ref":"NervesHubLink.Client.html#c:update_available/1"},{"type":"type","title":"NervesHubLink.Client.fwup_message/0","doc":"Firmware update progress, completion or error report","ref":"NervesHubLink.Client.html#t:fwup_message/0"},{"type":"type","title":"NervesHubLink.Client.update_data/0","doc":"Update that comes over a socket.","ref":"NervesHubLink.Client.html#t:update_data/0"},{"type":"type","title":"NervesHubLink.Client.update_response/0","doc":"Supported responses from `update_available/1`","ref":"NervesHubLink.Client.html#t:update_response/0"},{"type":"module","title":"NervesHubLink.Client.Default","doc":"Default NervesHubLink.Client implementation\n\nThis client always accepts an update.","ref":"NervesHubLink.Client.Default.html"},{"type":"behaviour","title":"NervesHubLink.Configurator","doc":"","ref":"NervesHubLink.Configurator.html"},{"type":"function","title":"NervesHubLink.Configurator.build/0","doc":"","ref":"NervesHubLink.Configurator.html#build/0"},{"type":"callback","title":"NervesHubLink.Configurator.build/1","doc":"","ref":"NervesHubLink.Configurator.html#c:build/1"},{"type":"module","title":"NervesHubLink.Configurator.Config","doc":"","ref":"NervesHubLink.Configurator.Config.html"},{"type":"type","title":"NervesHubLink.Configurator.Config.t/0","doc":"","ref":"NervesHubLink.Configurator.Config.html#t:t/0"},{"type":"module","title":"NervesHubLink.Configurator.Default","doc":"","ref":"NervesHubLink.Configurator.Default.html"},{"type":"module","title":"NervesHubLink.Configurator.NervesKey","doc":"","ref":"NervesHubLink.Configurator.NervesKey.html"},{"type":"module","title":"NervesHubLink.Configurator.SharedSecret","doc":"","ref":"NervesHubLink.Configurator.SharedSecret.html"},{"type":"function","title":"NervesHubLink.Configurator.SharedSecret.headers/1","doc":"Generate headers for Shared Secret Auth","ref":"NervesHubLink.Configurator.SharedSecret.html#headers/1"},{"type":"module","title":"NervesHubLink.Downloader","doc":"Handles downloading files via HTTP.\ninternally caches several interesting properties about\nthe download such as:\n\n  * the URI of the request\n  * the total content amounts of bytes of the file being downloaded\n  * the total amount of bytes downloaded at any given time\n\nUsing this information, it can restart a download using the\n[`Range` HTTP header](https://developer.mozilla.org/en-US/docs/Web/HTTP/Headers/Range).\n\nThis process's **only** focus is obtaining data reliably. It doesn't have any\nside effects on the system.","ref":"NervesHubLink.Downloader.html"},{"type":"function","title":"NervesHubLink.Downloader.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"NervesHubLink.Downloader.html#child_spec/1"},{"type":"function","title":"NervesHubLink.Downloader.start_download/2","doc":"Begins downloading a file at `url` handled by `fun`.\n\n# Example\n\n      iex> pid = self()\n      #PID<0.110.0>\n      iex> fun = fn {:data, data} -> File.write(\"index.html\", data)\n      ...> {:error, error} -> IO.puts(\"error streaming file: #{inspect(error)}\")\n      ...> :complete -> send pid, :complete\n      ...> end\n      #Function<44.97283095/1 in :erl_eval.expr/5>\n      iex> NervesHubLink.Downloader.start_download(\"https://httpbin.com/\", fun)\n      {:ok, #PID<0.111.0>}\n      iex> flush()\n      :complete","ref":"NervesHubLink.Downloader.html#start_download/2"},{"type":"function","title":"NervesHubLink.Downloader.start_download/3","doc":"","ref":"NervesHubLink.Downloader.html#start_download/3"},{"type":"type","title":"NervesHubLink.Downloader.event_handler_fun/0","doc":"","ref":"NervesHubLink.Downloader.html#t:event_handler_fun/0"},{"type":"type","title":"NervesHubLink.Downloader.handler_event/0","doc":"","ref":"NervesHubLink.Downloader.html#t:handler_event/0"},{"type":"type","title":"NervesHubLink.Downloader.initialized_download/0","doc":"","ref":"NervesHubLink.Downloader.html#t:initialized_download/0"},{"type":"type","title":"NervesHubLink.Downloader.resume_rescheduled/0","doc":"","ref":"NervesHubLink.Downloader.html#t:resume_rescheduled/0"},{"type":"type","title":"NervesHubLink.Downloader.retry_args/0","doc":"","ref":"NervesHubLink.Downloader.html#t:retry_args/0"},{"type":"type","title":"NervesHubLink.Downloader.t/0","doc":"","ref":"NervesHubLink.Downloader.html#t:t/0"},{"type":"module","title":"NervesHubLink.Downloader.RetryConfig","doc":"Configuration structure for how the Downloader server will\nhandle disconnects, errors, timeouts etc","ref":"NervesHubLink.Downloader.RetryConfig.html"},{"type":"type","title":"NervesHubLink.Downloader.RetryConfig.idle_timeout/0","doc":"time in milliseconds between chunks of data received\nthat once elapsed will trigger a retry. This event counts\ntowards the `max_disconnects` counter","ref":"NervesHubLink.Downloader.RetryConfig.html#t:idle_timeout/0"},{"type":"type","title":"NervesHubLink.Downloader.RetryConfig.max_disconnects/0","doc":"maximum number of disconnects. After this limit is reached\nthe download will be stopped and will no longer be retried","ref":"NervesHubLink.Downloader.RetryConfig.html#t:max_disconnects/0"},{"type":"type","title":"NervesHubLink.Downloader.RetryConfig.max_timeout/0","doc":"maximum time in milliseconds that a download can exist for.\nafter this amount of time has elapsed, the download is canceled\nand the download process will crash","ref":"NervesHubLink.Downloader.RetryConfig.html#t:max_timeout/0"},{"type":"type","title":"NervesHubLink.Downloader.RetryConfig.t/0","doc":"","ref":"NervesHubLink.Downloader.RetryConfig.html#t:t/0"},{"type":"type","title":"NervesHubLink.Downloader.RetryConfig.time_between_retries/0","doc":"time in milliseconds to wait before attempting to retry a download","ref":"NervesHubLink.Downloader.RetryConfig.html#t:time_between_retries/0"},{"type":"type","title":"NervesHubLink.Downloader.RetryConfig.worst_case_download_speed/0","doc":"worst case download speed specified in bytes per second. This is\nused to calculate the \"worst case\" download timeout. it is meant to\nfail faster than waiting for `max_timeout` to elapse","ref":"NervesHubLink.Downloader.RetryConfig.html#t:worst_case_download_speed/0"},{"type":"module","title":"NervesHubLink.Downloader.TimeoutCalculation","doc":"Pure functions for dealing with timeouts","ref":"NervesHubLink.Downloader.TimeoutCalculation.html"},{"type":"function","title":"NervesHubLink.Downloader.TimeoutCalculation.calculate_worst_case_timeout/2","doc":"Calculates the worst_case_timeout value based on content_length header and worst case network speed","ref":"NervesHubLink.Downloader.TimeoutCalculation.html#calculate_worst_case_timeout/2"},{"type":"type","title":"NervesHubLink.Downloader.TimeoutCalculation.bits_per_second/0","doc":"","ref":"NervesHubLink.Downloader.TimeoutCalculation.html#t:bits_per_second/0"},{"type":"type","title":"NervesHubLink.Downloader.TimeoutCalculation.number_of_bytes/0","doc":"","ref":"NervesHubLink.Downloader.TimeoutCalculation.html#t:number_of_bytes/0"},{"type":"module","title":"NervesHubLink.FwupConfig","doc":"Config structure responsible for handling callbacks from FWUP,\napplying a fwupdate, and storing fwup task configuration","ref":"NervesHubLink.FwupConfig.html"},{"type":"function","title":"NervesHubLink.FwupConfig.validate!/1","doc":"Raises an ArgumentError on invalid arguments","ref":"NervesHubLink.FwupConfig.html#validate!/1"},{"type":"type","title":"NervesHubLink.FwupConfig.fwup_message/0","doc":"`handle_fwup_message` will be called with this data","ref":"NervesHubLink.FwupConfig.html#t:fwup_message/0"},{"type":"type","title":"NervesHubLink.FwupConfig.handle_fwup_message_fun/0","doc":"Callback that will be called during the lifecycle of a fwupdate being applied","ref":"NervesHubLink.FwupConfig.html#t:handle_fwup_message_fun/0"},{"type":"type","title":"NervesHubLink.FwupConfig.t/0","doc":"","ref":"NervesHubLink.FwupConfig.html#t:t/0"},{"type":"type","title":"NervesHubLink.FwupConfig.update_available_fun/0","doc":"Called when an update has been dispatched via `NervesHubLink.UpdateManager.apply_update/2`","ref":"NervesHubLink.FwupConfig.html#t:update_available_fun/0"},{"type":"module","title":"NervesHubLink.HTTPFwupStream","doc":"Download and install a firmware update.","ref":"NervesHubLink.HTTPFwupStream.html"},{"type":"function","title":"NervesHubLink.HTTPFwupStream.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"NervesHubLink.HTTPFwupStream.html#child_spec/1"},{"type":"function","title":"NervesHubLink.HTTPFwupStream.get/2","doc":"Download and install the firmware at the specified URL","ref":"NervesHubLink.HTTPFwupStream.html#get/2"},{"type":"function","title":"NervesHubLink.HTTPFwupStream.get_header/2","doc":"","ref":"NervesHubLink.HTTPFwupStream.html#get_header/2"},{"type":"function","title":"NervesHubLink.HTTPFwupStream.start/1","doc":"","ref":"NervesHubLink.HTTPFwupStream.html#start/1"},{"type":"function","title":"NervesHubLink.HTTPFwupStream.start_link/1","doc":"Start the downloader process\n\nA `callback` process should be passed\n\nMessages will be received in the shape:\n\n* `{:fwup_message, message}` - see the docs for\n  [Fwup](https://hexdocs.pm/fwup/) for more info.\n* `{:http_error, {status_code, body}}`\n* `{:http_error, :timeout}`\n* `{:http_error, :too_many_redirects}`","ref":"NervesHubLink.HTTPFwupStream.html#start_link/1"},{"type":"function","title":"NervesHubLink.HTTPFwupStream.stop/1","doc":"Stop the downloader","ref":"NervesHubLink.HTTPFwupStream.html#stop/1"},{"type":"module","title":"NervesHubLink.Message.FirmwareMetadata","doc":"Structure containing metadata about a firmware.","ref":"NervesHubLink.Message.FirmwareMetadata.html"},{"type":"function","title":"NervesHubLink.Message.FirmwareMetadata.parse/1","doc":"","ref":"NervesHubLink.Message.FirmwareMetadata.html#parse/1"},{"type":"type","title":"NervesHubLink.Message.FirmwareMetadata.t/0","doc":"","ref":"NervesHubLink.Message.FirmwareMetadata.html#t:t/0"},{"type":"module","title":"NervesHubLink.Socket.State","doc":"","ref":"NervesHubLink.Socket.State.html"},{"type":"type","title":"NervesHubLink.Socket.State.t/0","doc":"","ref":"NervesHubLink.Socket.State.html#t:t/0"},{"type":"module","title":"NervesHubLink.UpdateManager","doc":"GenServer responsible for brokering messages between:\n  * an external controlling process\n  * FWUP\n  * HTTP\n\nShould be started in a supervision tree","ref":"NervesHubLink.UpdateManager.html"},{"type":"function","title":"NervesHubLink.UpdateManager.add_fwup_public_key/2","doc":"Add a FWUP Public key","ref":"NervesHubLink.UpdateManager.html#add_fwup_public_key/2"},{"type":"function","title":"NervesHubLink.UpdateManager.apply_update/2","doc":"Must be called when an update payload is dispatched from\nNervesHub. the map must contain a `\"firmware_url\"` key.","ref":"NervesHubLink.UpdateManager.html#apply_update/2"},{"type":"function","title":"NervesHubLink.UpdateManager.currently_downloading_uuid/1","doc":"Returns the UUID of the currently downloading firmware, or nil.","ref":"NervesHubLink.UpdateManager.html#currently_downloading_uuid/1"},{"type":"function","title":"NervesHubLink.UpdateManager.remove_fwup_public_key/2","doc":"Remove a FWUP public key","ref":"NervesHubLink.UpdateManager.html#remove_fwup_public_key/2"},{"type":"function","title":"NervesHubLink.UpdateManager.status/1","doc":"Returns the current status of the update manager","ref":"NervesHubLink.UpdateManager.html#status/1"},{"type":"module","title":"NervesHubLink.UpdateManager.State","doc":"Structure for the state of the `UpdateManager` server.\nContains types that describe status and different states the\n`UpdateManager` can be in","ref":"NervesHubLink.UpdateManager.State.html"},{"type":"type","title":"NervesHubLink.UpdateManager.State.status/0","doc":"","ref":"NervesHubLink.UpdateManager.State.html#t:status/0"},{"type":"type","title":"NervesHubLink.UpdateManager.State.t/0","doc":"","ref":"NervesHubLink.UpdateManager.State.html#t:t/0"},{"type":"module","title":"NervesHubLink.UploadFile.State","doc":"","ref":"NervesHubLink.UploadFile.State.html"},{"type":"type","title":"NervesHubLink.UploadFile.State.t/0","doc":"","ref":"NervesHubLink.UploadFile.State.html#t:t/0"},{"type":"extras","title":"NervesHubLink","doc":"# NervesHubLink\n\n[![CircleCI](https://circleci.com/gh/nerves-hub/nerves_hub_link/tree/main.svg?style=svg)](https://circleci.com/gh/nerves-hub/nerves_hub_link/tree/main)\n[![Hex version](https://img.shields.io/hexpm/v/nerves_hub_link.svg \"Hex version\")](https://hex.pm/packages/nerves_hub_link)\n\n**Important**\n\nThis is the 2.0 development branch of NervesHubLink. If you have been using NervesHub prior to around April, 2023 and are not following 2.0 development, see the `maint-v1` branch. The `maint-v1` branch is being used in production. 2.0 development is in progress, and we don't have guides or good documentation yet. If you use the 2.0 development branch, we don't expect breaking changes, but please bear with us as we complete the 2.0 release.\n\n---\n\nThis is the official client for devices that want to receive firmware updates from NervesHub.","ref":"readme.html"},{"type":"extras","title":"Overview - NervesHubLink","doc":"NervesHub is an open-source firmware update server that works well with\nNerves-based devices. A managed version is available at\n[nerves-hub.org](https://nerves-hub.org) and it's possible to host your own.\n\nNervesHub provides many of the features that you'd expect in a firmware update\nserver. Fundamentally, devices connect to the server by joining a long-lived Phoenix\nchannel (for HTTP polling, see [nerves_hub_link_http](https://github.com/nerves-hub/nerves_hub_link_http)).\nIf a firmware update is available, NervesHub will provide a URL to the device and the\ndevice can update immediately or [when convenient](https://github.com/nerves-hub/nerves_hub_link#conditionally-applying-updates).\n\nNervesHub does impose some requirements on devices and firmware that may require\nchanges to your Nerves projects:\n\n* Firmware images are cryptographically signed (both NervesHub and devices\n  validate signatures)\n* Devices are identified by a unique serial number\n* Each device has its own SSL certificate for authentication with NervesHub\n\nThese changes enable NervesHub to provide assurances that the firmware bits\nyou intend to install on a set of devices make it to those devices unaltered.","ref":"readme.html#overview"},{"type":"extras","title":"Getting started - NervesHubLink","doc":"The following sections will walk you through updating your Nerves project to\nwork with the [nerves-hub.org](https://nerves-hub.org) NervesHub server. Using\nyour own NervesHub server will require setting URLs to point elsewhere and is\nnot covered below to simplify first usage.\n\nMany of the steps below may feel manual, but they can and are automated by\nNervesHub users to set up automatic firmware updates from CI and to manufacture\nlarge numbers of devices.\n\n#","ref":"readme.html#getting-started"},{"type":"extras","title":"Adding NervesHubLink to your project - NervesHubLink","doc":"The first step is to add `nerves_hub_link` to your target dependencies in your\nproject's `mix.exs`. Since NervesHub uses SSL certificates, the time must be set\non the device or certificate validity checks will fail. If you're not already\nsetting the time, add [`nerves_time`](https://hex.pm/packages/nerves_time) to\nyour dependencies. For example:\n\n```elixir\n  defp deps(target) do\n    [\n      {:nerves_runtime, \"~> 0.11\"},\n      {:nerves_hub_link, \"~> 0.11\"},\n      {:nerves_time, \"~> 0.4\"},\n      ...\n    ] ++ system(target)\n  end\n```\n\nNext, update your `config.exs` so that the `nerves_hub_link` library can help\nprovision devices. Do this by adding `provisioning: :nerves_hub_link` to the\n`:nerves, :firmware` option like this:\n\n```elixir\nconfig :nerves, :firmware,\n  provisioning: :nerves_hub_link\n```\n\nThe library won't connect to [nerves-hub.org](https://nerves-hub.org) unless\nrequested and SSL options must be configured.\n\nIf using [NervesKey](https://github.com/nerves-hub/nerves_key), you can tell\n`NervesHubLink` to read those certificates and key from the chip and assign\nthe SSL options for you by enabling add it as a dependency:\n\n```elixir\ndef deps() do\n  [\n    {:nerves_key, \"~> 0.5\"}\n  ]\nend\n```\n\nNervesKey will default to using I2C bus 1 and the `:primary` certificate pair\n(`:primary` is one-time configurable and `:aux` may be updated).  You can\ncustomize these options to use a different bus and certificate pair:\n\n```elixir\nconfig :nerves_hub_link, :nerves_key,\n  certificate_pair: :aux,\n  i2c_bus: 0\n```\n\nIf you aren't using NervesKey, you can also provide your own options\nto use for the NervesHub socket connection via the `:socket` and `:ssl` keys,\nwhich are forwarded on to `phoenix_client` when creating the socket connection (see\n[`PhoenixClient.Socket`\nmodule](https://github.com/mobileoverlord/phoenix_client/blob/main/lib/phoenix_client/socket.ex#L57-L91)\nfor support options.\n\nAny [valid Erlang ssl socket\noption](http://erlang.org/doc/man/ssl.html#TLS/DTLS%20OPTION%20DESCRIPTIONS%20-%20COMMON%20for%20SERVER%20and%20CLIENT)\ncan go in the `:ssl` key.\n\n```elixir\nconfig :nerves_hub_link,\n  socket: [\n    json_library: Jason,\n    heartbeat_interval: 45_000\n  ],\n  ssl: [\n    cert: \"some_cert_der\",\n    keyfile: \"path/to/keyfile\"\n  ]\n```\n\n#","ref":"readme.html#adding-nerveshublink-to-your-project"},{"type":"extras","title":"Runtime configuration - NervesHubLink","doc":"Some cases require that connection configuration happens at runtime like\nselectively choosing which cert/key to use based on device, or reading a file\nstored on device which isn't available during compilation.\n\nWhatever the reason, `NervesHubLink` also supports runtime configuration via the\n`NervesHubLink.Configurator` behavior. This is called during application startup\nto build the configuration that is to be used for the connection. When\nimplementing the behavior, you'll receive the initial default config read in\nfrom the application environment and you can modify it however you need.\n\nFor example:\n\n```elixir\ndefmodule MyApp.Configurator do\n  @behaviour NervesHubLink.Configurator\n\n  @impl NervesHubLink.Configurator\n  def build(config) do\n    ssl = [certfile: \"/root/ssl/cert.pem\", keyfile: \"/root/ssl/key.pem\"]\n    %{config | ssl: ssl}\n  end\nend\n```\n\nThen you specify which configurator `NervesHubLink` should use in `config.exs`:\n\n```elixir\nconfig :nerves_hub_link, configurator: MyApp.Configurator\n```\n\n#","ref":"readme.html#runtime-configuration"},{"type":"extras","title":"Creating a NervesHub product - NervesHubLink","doc":"A NervesHub product groups devices that run the same kind of firmware. All\ndevices and firmware images have a product. NervesHub provides finer grain\nmechanisms for grouping devices, but a product is needed to get started.\n\nBy default, NervesHub uses the `:app` name in your `mix.exs` for the product\nname. If you would like it to use a different name, add a `:name` field to your\n`Mix.Project.config()`. For example, NervesHub would use \"My Example\" instead of\n\"example\" for the following project:\n\n```elixir\n  def project do\n    [\n      app: :example,\n      name: \"My Example\"\n    ]\n  end\n```\n\nFor the remainder of this document, though, we will not use the `:name` field\nand simply use the product name `example`.\n\nCreate a new product on NervesHub by running:\n\n```bash\nmix nerves_hub.product create\n```\n\n#","ref":"readme.html#creating-a-nerveshub-product"},{"type":"extras","title":"Creating NervesHub firmware signing keys - NervesHubLink","doc":"NervesHub requires cryptographic signatures on all managed firmware. Devices\nreceiving firmware from NervesHub validate signatures. Since firmware is signed\nbefore uploading to NervesHub, NervesHub or any service NervesHub uses cannot\nmodify it.\n\nFirmware authentication uses [Ed25519 digital\nsignatures](https://en.wikipedia.org/wiki/EdDSA#Ed25519). You need to create at\nleast one public/private key pair and copy the public key part to NervesHub and\nto devices. NervesHub tooling helps with both. A typical setup has multiple\nsigning keys to support key rotation and \"development\" keys that are not as\nprotected.\n\nStart by creating a `devkey` firmware signing key pair:\n\n```bash\nmix nerves_hub.key create devkey\n```\n\nOn success, you'll see the public key. You can confirm using the NervesHub web\ninterface that the public key exists. Private keys are never sent to the\nNervesHub server. NervesHub requires valid signatures from known keys on all\nfirmware it distributes.\n\nThe next step is to make sure that the public key is embedded into the firmware\nimage. This is important. The device uses this key to verify the firmware it\nreceives from a NervesHub server before applying the update. This protects the\ndevice against anyone tampering with the firmware image between when it was\nsigned by you and when it is installed.\n\nAll firmware signing public keys need to be added to your `config.exs`.\n\n```elixir\nconfig :nerves_hub_link,\n  fwup_public_keys: [\n    # devkey\n    \"bM/O9+ykZhCWx8uZVgx0sU3f0JJX7mqnAVU9VGeuHr4=\"\n  ]\n```\n\nThe `nerves_hub_link` dependency converts key names to public keys at compile time.\nIf you haven't compiled your project yet, run `mix firmware` now. If you have\ncompiled it, `mix` won't know to recompile `nerves_hub_link` due to the configuration\nchange. Force it to recompile by running:\n\n```bash\nmix deps.compile nerves_hub_link --force\nmix firmware\n```\n\nWhile not shown here, you can export keys for safe storage. Additionally, key\ncreation and firmware signing can be done outside of the `mix` tooling. The only\npart that is required is that the firmware signing public keys be added to your\n`config.exs` and to the NervesHub server.\n\n#","ref":"readme.html#creating-nerveshub-firmware-signing-keys"},{"type":"extras","title":"Publishing firmware - NervesHubLink","doc":"Uploading firmware to NervesHub is called publishing. To publish firmware start\nby calling:\n\n```bash\nmix firmware\n```\n\nFirmware can only be published if has been signed. You can sign the firmware by\nrunning.\n\n```bash\nmix nerves_hub.firmware sign --key devkey\n```\n\nFirmware can also be signed while publishing:\n\n```bash\nmix nerves_hub.firmware publish --key devkey\n```\n\n#","ref":"readme.html#publishing-firmware"},{"type":"extras","title":"Initializing devices - NervesHubLink","doc":"In this example we will create a device with a hardware identifier `1234`.  The\ndevice will also be tagged with `qa` so we can target it in our deployment\ngroup. We will select `y` when asked if we would like to generate device\ncertificates. Device certificates are required for a device to establish a\nconnection with the NervesHub server. However, if you are using [NervesKey](https://github.com/nerves-hub/nerves_key),\nyou can select `n` to skip generating device certificates.\n\n```bash\n$ mix nerves_hub.device create\n\nNervesHub organization: nerveshub\nidentifier: 1234\ndescription: test-1234\ntags: qa\nLocal user password:\nDevice 1234 created\nWould you like to generate certificates? [Yn] y\nCreating certificate for 1234\nFinished\n```\n\nIt is important to note that device certificate private keys are generated and\nstay on your host computer. A certificate signing request is sent to the server,\nand a signed public key is passed back. Generated certificates will be placed in\na folder titled `nerves-hub` in the current working directory. You can specify a\ndifferent location by passing `--path /path/to/certs` to NervesHubCLI mix\ncommands.\n\nNervesHub certificates and hardware identifiers are persisted to the firmware\nwhen the firmware is burned to the SD card. To make this process easier, you can\ncall `nerves_hub.device burn IDENTIFIER`. In this example, we are going to burn\nthe firmware and certificates for device `1234` that we created.\n\n```bash\nmix nerves_hub.device burn 1234\n```\n\nYour device will now connect to NervesHub when it boots and establishes an\nnetwork connection.\n\n#","ref":"readme.html#initializing-devices"},{"type":"extras","title":"Creating deployments - NervesHubLink","doc":"Deployments associate firmware images to devices. NervesHub won't send firmware\nto a device until you create a deployment. First find the UUID of the firmware.\nYou can list the firmware on NervesHub by calling:\n\n```bash\nmix nerves_hub.firmware list\n\nFirmwares:\n------------\n  product:      example\n  version:      0.3.0\n  platform:     rpi3\n  architecture: arm\n  uuid:         1cbecdbb-aa7d-5aee-4ba2-864d518417df\n```\n\nIn this example we will create a new deployment for our test group using firmware\n`1cbecdbb-aa7d-5aee-4ba2-864d518417df`.\n\n```bash\nmix nerves_hub.deployment create\n\nNervesHub organization: nerveshub\nDeployment name: qa_deployment\nfirmware uuid: 1cbecdbb-aa7d-5aee-4ba2-864d518417df\nversion condition:\ntags: qa\nLocal user password:\nDeployment test created\n```\n\nHere we create a new deployment called `qa_deployment`. In the conditions of this\ndeployment we left the `version condition` unspecified and the `tags` set to\nonly `qa`.  This means that in order for a device to qualify for an update, it\nneeds to have at least the tags `[qa]` and the device can be coming from any\nversion.\n\nAt this point we can try to update the connected device.\n\nStart by bumping the application version number from `0.1.0` to `0.1.1`. Then,\ncreate new firmware:\n\n```bash\nmix firmware\n```\n\nWe can publish, sign, and deploy firmware in a single command now.\n\n```bash\nmix nerves_hub.firmware publish --key devkey --deploy qa_deployment\n```\n\n#","ref":"readme.html#creating-deployments"},{"type":"extras","title":"Conditionally applying updates - NervesHubLink","doc":"It's not always appropriate to apply a firmware update immediately.\nCustom logic can be added to the device by implementing the `NervesHubLink.Client` behaviour and telling the NervesHubLink OTP application about it.\n\nHere's an example implementation:\n\n```elixir\ndefmodule MyApp.NervesHubLinkClient do\n   @behaviour NervesHubLink.Client\n\n   # May return:\n   #  * `:apply` - apply the action immediately\n   #  * `:ignore` - don't apply the action, don't ask again.\n   #  * `{:reschedule, timeout_in_milliseconds}` - call this function again later.\n\n   @impl NervesHubLink.Client\n   def update_available(data) do\n    if SomeInternalAPI.is_now_a_good_time_to_update?(data) do\n      :apply\n    else\n      {:reschedule, 60_000}\n    end\n   end\nend\n```\n\nTo have NervesHubLink invoke it, update your `config.exs` as follows:\n\n```elixir\nconfig :nerves_hub_link, client: MyApp.NervesHubLinkClient\n```\n\n#","ref":"readme.html#conditionally-applying-updates"},{"type":"extras","title":"Reporting update progress - NervesHubLink","doc":"See the previous section for implementing a `client` behaviour.\n\n```elixir\ndefmodule MyApp.NervesHubLinkClient do\n   @behaviour NervesHubLink.Client\n    #  argument can be:\n    #   {:ok, non_neg_integer(), String.t()}\n    #   {:warning, non_neg_integer(), String.t()}\n    #   {:error, non_neg_integer(), String.t()}\n    #   {:progress, 0..100}\n    def handle_fwup_message({:ok, _, _}) do\n      Logger.error(\"Firmware update complete\")\n      :ok\n    end\n\n    def handle_fwup_message({:warning, code, message}) do\n      Logger.error(\"Warning while applying firmware update (#{code)}): #{message}\")\n      :ok\n    end\n\n    def handle_fwup_message({:error, _, message}) do\n      Logger.error(\"Error while applying firmware update #(#{code}): {message}\")\n      :ok\n    end\n\n    def handle_fwup_message({:progress, progress}) when rem(progress, 10) do\n      Logger.info(\"Update progress: #{progress}%\")\n      :ok\n    end\n\n    def handle_fwup_message({:progress, _}) do\n      :ok\n    end\nend\n```\n\n#","ref":"readme.html#reporting-update-progress"},{"type":"extras","title":"Enabling remote IEx access - NervesHubLink","doc":"It's possible to remotely log into your device via the NervesHub web interface. This\nfeature is disabled by default. To enable, add the following to your `config.exs`:\n\n```elixir\nconfig :nerves_hub_link, remote_iex: true\n```\n\nThe remote IEx process is started on the first data request from NervesHub and is\nterminated after 5 minutes of inactivity. You can adjust this by setting\n`:remote_iex_timeout` value in seconds in your `config.exs`:\n\n```elixir\nconfig :nerves_hub_link, remote_iex_timeout: 900 # 15 minutes\n```\n\nYou may also need additional permissions on NervesHub to see the device and to use the\nremote IEx feature.","ref":"readme.html#enabling-remote-iex-access"},{"type":"extras","title":"CA Certificates - NervesHubLink","doc":"If you are connecting to your own instance with custom CA certificates, use the\n`:ca_store` option to specific a module with a `ca_certs/0` function that returns\na list of DER encoded certificates:\n\n```elixir\nconfig :nerves_hub_link, ca_store: MyModule\n```\n\nOr if you have the certificates in DER format, you can also explicitly set them in the :ssl option:\n\n```elixir\nmy_der_list = [<<213, 34, 234, 53, 83, 8, 2, ...>>]\nconfig :nerves_hub_link, ssl: [cacerts: my_der_list]\n```","ref":"readme.html#ca-certificates"},{"type":"extras","title":"Debugging errors - NervesHubLink","doc":"#","ref":"readme.html#debugging-errors"},{"type":"extras","title":"TLS client errors - NervesHubLink","doc":"If you see the following in your logs:\n\n```text\n14:26:06.926 [info]  ['TLS', 32, 'client', 58, 32, 73, 110, 32, 115, 116, 97, 116, 101, 32, 'cipher', 32, 'received SERVER ALERT: Fatal - Unknown CA', 10]\n```\n\nThis probably indicates that the signing certificate hasn't been uploaded to\nnerves-hub.org so the device can't be authenticated. Double check that you ran:\n\n```sh\nmix nerves_hub.ca_certificate register my-signer.cert\n```\n\nAnother possibility is that the device wasn't provisioned with the certificate\nthat's on nerves-hub.org.\n\nSee also [NervesHubWeb: Potential SSL Issues](https://github.com/nerves-hub/nerves_hub_web#potential-ssl-issues)","ref":"readme.html#tls-client-errors"},{"type":"extras","title":"Changelog","doc":"# Changelog\n\n## [2.1.1] - 2024-02-05\n\n* Fixed\n  * `UploadFile` stream changed to be backwards compatible with Elixir 1.16 and older\n\n## [2.1.0] - 2024-02-05\n\nThis update should be relatively safe and backwards compatible. It introduces some\nnew features with NervesHub including Pre-shared key authentication and file\nupload/download ability through the console channge. If you were previously\nrelying on `NervesHubLink.Connection` functions then you will need to review\nand update your code to use `NervesHubLink` connection functions instead.\n\n* Removed\n  * `NervesHubLink.Connection` was removed in favor is using the connection\n    state of the socket instead.\n\n* Added\n  * Use the console channel to save files to the device (#131)\n  * Send a file to an attached NervesHub web console (#130)\n  * Pre-shared key authentication as an alternative to certificate authentication\n\n* Updated\n  * Default SNI from host if none specified\n  * Default to CAStore when no `:ca_certs` are provided\n\n## [2.0.0] - 2023-08-22\n\nThe new release of NervesHubLink starts adding new features from NervesHub 2.0, such as identifying the device you have open in NervesHub and hooks to help prevent a thundering herd of device reconnects. It also cleans up the code base a bit by removing unused packages. Make sure to run mix deps.unlock --unused after updating to keep your lock file up to date.\n\n* Removed\n  * NervesHubCLI and NervesHubCAStore as dependencies\n  * NervesHubLinkCommon as dependencies, it was merged into this repo\n\n* Added\n  * Identify callback from NervesHub, a new message from the server that\n    will let you blink an LED or anything else that will help you identify\n    the device you're looking at is the one you have open in NervesHub.\n  * Add a client callback for changing the backoff timeouts on reconnects\n    (#128)\n\n## [1.4.1] - 2023-05-26\n\n* Added\n  * Expose `NervesHubLink.console_active?` for checking active IEx sessions (#123)\n  * Improvements for Elixir 1.15 and OTP 26\n\n* Fixed\n  * Stops IEx process with `:normal` instead of causing a crash (#121)\n\n## [1.4.0] - 2022-10-07\n\n* Fixed\n  * Default to TLS 1.2 for all connections. This fixes issues if TLS 1.3 is\n    used or attempted. See [NervesHubWeb: Potential SSL Issues](https://github.com/nerves-hub/nerves_hub_web#potential-ssl-issues)\n    for more information.\n\n## [1.3.0] - 2022-09-06\n\n* Fixed\n  * Use `Slipstream.push/5` for safe publishing\n  * Don't apply update by default if the UUID is the same\n\n## [1.2.0] - 2022-05-13\n\n* `:nerves_hub_link_common 0.4.0`\n\n* Removed\n  * Elixir 1.10 is no longer supported. This matches the minimum version of\n    `nerves_hub_link_common` which is Elixir 1.11\n\n* Fixed\n  * Allow for `:slipstream ~> 1.0`\n\n## [1.1.0] - 2021-12-09\n\n* Removed\n  * Elixir 1.8 and 1.9 are no longer supported. These hadn't been tested on CI\n    and were removed when we started testing Elixir 1.13.\n\n* Added\n  * Retry timeouts are now being set on Slipstream via the\n    `:reconnect_after_msec` parameter.  The timeouts start at 1 second and\n    double up to 60 seconds plus a random amount of jitter. Previously the\n    timeouts started under a second and maxed out at 5 seconds without jitter.\n    These timeouts were chosen to reduce the load on NervesHub servers when\n    large numbers of devices disconnect. They can be overridden.\n\n## [1.0.1] - 2021-11-16\n\n* Fixed\n  * A crash in the remote console would occur if a window resize message was received\n    before the IEx process was started\n\n## [1.0.0] - 2021-10-25\n\nThis release only bumps the version number. It doesn't have any code changes.\n\n## [0.13.1] - 2021-10-19\n\n* Fixed\n  * `NervesHubLink.reconnect/0` no longer times out and instead disconnects\n    the socket forcing the reconnection logic\n\n## [0.13.0] - 2021-10-01\n\n#","ref":"changelog.html"},{"type":"extras","title":"Potentially Breaking - Changelog","doc":"* Added\n  * Switch the websocket client to the [Slipstream](https://github.com/NFIBrokerage/slipstream)\n    library for communication with NervesHub. There are no API changes. This should only be\n    a change to the internals, but you may notice timing differences especially around retries.\n\n## [0.12.1] - 2021-08-19\n\n* Added\n  * `NervesHubLink.reconnect/0` to force reconnection of the socket and channels","ref":"changelog.html#potentially-breaking"},{"type":"extras","title":"0.12.0 - Changelog","doc":"* fwup 1.0.0\n\n* Enhancements\n  * added `:fwup_env` option to the Configurator to support\n    environment variables which are needed in `fwup`","ref":"changelog.html#0-12-0"},{"type":"extras","title":"0.11.0 - Changelog","doc":"* Breaking Changes\n  * This release includes a change to how CA certificates are used in the connection\n    to NervesHub. If you are connecting to the publicly hosted https://nerves-hub.org,\n    then no changes are required.\n    If you are manually supplying `:ca_certs` config value to connect to another instance\n    of NervesHub, then you will need to update you config following the instructions of\n    [CA Certificates](https://hexdocs.pm/nerves_hub_link/readme.html#ca-certificates) in the README.","ref":"changelog.html#0-11-0"},{"type":"extras","title":"0.10.2 - Changelog","doc":"* Fixes\n  * Fix issue that allowed unresolved atom keys in `:fwup_public_keys`\n    config which would break firmware updates by failing to validate\n    the public key\n  * Add missing dependency on `:inets`","ref":"changelog.html#0-10-2"},{"type":"extras","title":"0.10.1 - Changelog","doc":"* Fixes\n  * Fix typo that would cause the device to fail to reboot after applying\n    an update","ref":"changelog.html#0-10-1"},{"type":"extras","title":"0.10.0 - Changelog","doc":"* `nerves_hub_link_common 0.2.0`\n\n* Potential Breaking Changes\n  * This enforces the update data structure exchanged between device and server\n    and is mostly internal. However, if you implement your own `NervesHubLink.Client`\n    behavior, then you will need to your `NervesHubLink.Client.update_available/1` to\n    accept a `%NervesHubLink.Message.UpdateInfo{}` struct as the parameter\n    instead of a map with string keys which was used until this point.\n\n* Enhancements\n  * Report API version to NervesHub. While there's currently only one version of\n    the Device API, this is anticipation that we may want to change it in the future.\n  * On reconnect, notify NervesHub of firmware currently being downloaded so\n    that NervesHub can differentiate failed firmware updates from network hiccups.\n  * Allow devices to implement their own reboot logic by implementing the\n    `NervesHubLink.Client.reboot/0` callback\n\n* Fixes\n  * Check `firmware_url` is valid before attempting update","ref":"changelog.html#0-10-0"},{"type":"extras","title":"0.9.4 - Changelog","doc":"* Enhancements\n  * Supports resuming failed downloads by offloading the responsibility of downloading\n  and applying updates to a new package: `nerves_hub_link_common`","ref":"changelog.html#0-9-4"},{"type":"extras","title":"v0.9.3 - Changelog","doc":"* Fixes\n  * Fixes misleading default error message report\n  * Ensures `:nerves_key` is started before use to deal with optional dependency\n  start order bug","ref":"changelog.html#v0-9-3"},{"type":"extras","title":"v0.9.2 - Changelog","doc":"* Enhancements\n  * Supports incoming `window_size` message from web channel to change the TTY size","ref":"changelog.html#v0-9-2"},{"type":"extras","title":"v0.9.1 - Changelog","doc":"* Enhancements\n  * Send fwup version to server when connecting. This is required If you are using patchable firmware updates.","ref":"changelog.html#v0-9-1"},{"type":"extras","title":"v0.9.0 - Changelog","doc":"This release supports the new NervesHub console terminal. After upgrading,\nremote sessions should look almost the same as `ssh`-based ones: tab-completion,\ncolors, and commandline history work as expected now.","ref":"changelog.html#v0-9-0"},{"type":"extras","title":"v0.8.2 - Changelog","doc":"* Bug Fixes\n  * Fixes a broken call to `handle_fwup_message` on fwup success (thanks @bmteller! :heart:)","ref":"changelog.html#v0-8-2"},{"type":"extras","title":"v0.8.1 - Changelog","doc":"* Enhancements\n  * Flatten console data being sent to NervesHub\n  * Log all fwup progress percentage messages","ref":"changelog.html#v0-8-1"},{"type":"extras","title":"v0.8.0 - Changelog","doc":"* `nerves_hub_cli -> 0.10.0` - This decouples the CLI from the deprecated `:nerves_hub`\nlib and frees this lib to do the same. If you are setting `:nerves_hub, org: org` in\nyour config, compilation will fail until you change it to use this lib key:\n\n```elixir\nconfig :nerves_hub_link, org: org\n```\n* `nerves_hub_user_api -> 0.6.0`\n\n* Enhancements\n  * Updates example app\n  * Cleanup and structural changes\n  * The default NervesHub certificates are no longer stored in the `priv` directory so\n  if you're not using them, they won't be included.\n\n* Fixes\n  * Fixes an issue where a device may get an update message from the server while\n  performing an update which would cause things to crash.\n  * decouples `:nerves_hub` config values - see note above","ref":"changelog.html#v0-8-0"},{"type":"extras","title":"v0.7.6 - Changelog","doc":"Various cleanup and structure changes\n\n* Enhancements\n  * Add `Configurator` behavior - Gives the user a chance to do some configuration at runtime\n  * `:nerves_key` as optional dep","ref":"changelog.html#v0-7-6"},{"type":"extras","title":"v0.7.5 - Changelog","doc":"* Bug fixes\n  * Check NervesKey is provisioned before attempting to use it","ref":"changelog.html#v0-7-5"},{"type":"extras","title":"v0.7.4 - Changelog","doc":"* Enhancements\n  * Rename to `NervesHubDevice`\n  * Remove `HTTP` support to use channels exclusively\n  * Reorganize as a an `Application` and remove ability to start a supervisor separately\n  * Support using `NervesKey` via a configuartion flag","ref":"changelog.html#v0-7-4"},{"type":"extras","title":"v0.7.3 - Changelog","doc":"* Bug fixes\n  * Fix a NervesHub remote console issue due to missing `:io_request` handling\n\n* Enhancements\n  * Add support for querying the NervesHub connection state so that this is\n    easier to plug into Erlang's heart callback. This makes it possible to have\n    a device automatically reboot if it can't reach NervesHub for a long\n    time as a last ditch attempt at recovery. This has to be hooked up.","ref":"changelog.html#v0-7-3"},{"type":"extras","title":"v0.7.2 - Changelog","doc":"* Enhancements\n  * Report firmware update progress so it can be monitored on NervesHub.","ref":"changelog.html#v0-7-2"},{"type":"extras","title":"v0.7.1 - Changelog","doc":"* Bug fixes\n  * Handle firmware download connection timeout to fail more quickly when\n    connections fail","ref":"changelog.html#v0-7-1"},{"type":"extras","title":"v0.7.0 - Changelog","doc":"* New features\n  * Support remote IEx access from authorized NervesHub users, but only if\n    enabled. To enable, add `config :nerves_hub, remote_iex: true` to your\n    `config.exs`","ref":"changelog.html#v0-7-0"},{"type":"extras","title":"v0.6.0 - Changelog","doc":"* New features\n  * Support remote reboot request from NervesHub\n\n* Bug fixes\n  * Fix decoding of private key from KV","ref":"changelog.html#v0-6-0"},{"type":"extras","title":"v0.5.1 - Changelog","doc":"* Bug fixes\n  * Increased download hang timeout to deal with slow networks and <1 minute\n    long hiccups\n  * Fixed naming collision with a named process","ref":"changelog.html#v0-5-1"},{"type":"extras","title":"v0.5.0 - Changelog","doc":"* Enhancements\n  * nerves_hub_cli: Bump to v0.7.0\n  * The Phoenix Channel connection no longer uses the topic `firmware:firmware_uuid`\n    and instead connects to the topic `device`.","ref":"changelog.html#v0-5-0"},{"type":"extras","title":"v0.4.0 - Changelog","doc":"This release has backwards incompatible changes so please read carefully.\n\nThe configuration key for firmware signing keys has changed from `:public_keys`\nto `:fwup_public_keys`.\n\nIf you are not using nerves-hub.org for your NervesHub server, the configuration\nkeys for specifying the device endpoint for the server have changed. Look for\n`:device_api_host` and `:device_api_port` in the documentation and example for\nsetting these.\n\n* Enhancements\n  * All firmware metadata is now passed up to the NervesHub. This will make it\n    possible for the server to make decisions on firmware that has been loaded\n    outside of NervesHub or old firmware that has been unloaded from NervesHub.\n  * Code cleanup and refactoring throughout. More passes are planned.","ref":"changelog.html#v0-4-0"},{"type":"extras","title":"v0.3.0 - Changelog","doc":"* Enhancements\n  * Add uuid and dn to http headers for polling requests\n\n* Bug fixes\n  * Fix crash when no updates were available","ref":"changelog.html#v0-3-0"},{"type":"extras","title":"v0.2.1 - Changelog","doc":"* Bug fixes\n  * Use CA certificates from `:nerves_hub` instead of `:nerves_hub_core`.","ref":"changelog.html#v0-2-1"},{"type":"extras","title":"v0.2.0 - Changelog","doc":"* Enhancements\n  * Updated docs.\n  * Added support for [NervesKey](https://github.com/nerves-hub/nerves_key).\n  * Added support for performing conditional updates.\n  * Include `fwup` elixir dependency for interfacing with `fwup`.\n  * Update deps and code to make it possible to run on host for testing.\n  * Automatically call `NervesHub.connect()` instead of requiring it to be specified.\n  * Improved error handling and reporting.","ref":"changelog.html#v0-2-0"},{"type":"extras","title":"v0.1.0 - Changelog","doc":"Initial release","ref":"changelog.html#v0-1-0"}],"content_type":"text/markdown"}